      subroutine aground
     & (rsogrou, rdsgrou, rsdgrou, rddgrou)
c
c   Directional-hemispherical reflectance rsdground and albedo 
c   (hemispherical-hemispherical reflectance) rddgrou 
c   of ground vegetation.                          A. Kuusk  5.9.2002
c   Input:
c     & (thknot, phi, p14,
c     & rlambda, pkhair, 
c     & lmod2, ncomp2, ul2, sl2, szz, eln2, thm2,
c     & slw2, rnc2, vai2, asp2, ccomp2,
c     & lmod1, ncomp1, ul1, sl1, eln1, thm1,
c     & slw1, rnc1, vai1, asp1, ccomp1,
c     & thss, rsl1, rsl2, rsl3, rsl4,
c   Output:
c   & rsogrou, rdsgrou, rsdgrou, rddgrou)
c
      include 'par.h'
      include 'func.h'
c
c           ! Albedo of ground vegetation is calculated integrating
c           ! ACRM with Gauss quadrature in the perpendicular plain
c           ! phi = 90 deg
c
      phisave  = phi
      thets = ths
      thetv = thv
      skyl  = 1.d0
      call smcrm
     &  (thets, thetv, ggv, penalty, bc1, bs1, bdplants, bdsoil)
      sbgr = (1.d0 -skyl)*(bc1 + bs1) + bdplants + bdsoil
      rdsgrou = sbgr
c
      skyl  = 0.d0
      call smcrm
     &  (thets, thetv, ggv, penalty, bc1, bs1, bdplants, bdsoil)
      sbgr = (1.d0 -skyl)*(bc1 + bs1) + bdplants + bdsoil
      rsogrou = sbgr
c
      phi   = pi/2.d0
      rsdgrou = 0.d0
      do jthk = 1, nknots
         thetv  = thknot(jthk)
         call smcrm
     &  (thets, thetv, ggv, penalty, bc1, bs1, bdplants, bdsoil)
         sbgr = (1.d0 -skyl)*(bc1 + bs1) + bdplants + bdsoil
         rsdgrou = rsdgrou + p14(jthk)*sbgr
      enddo
c
      rddgrou = 0.d0
      do jthk = 1, nknots
         thets = thknot(jthk)
         rsdg  = 0.d0
         do jv = 1, nknots
            thetv   = thknot(jv)
            call smcrm
     &  (thets, thetv, ggv, penalty, bc1, bs1, bdplants, bdsoil)
            sbgr = (1.d0 -skyl)*(bc1 + bs1) + bdplants + bdsoil
            rsdg = rsdg + p14(jv)*sbgr
         enddo
         rddgrou = rddgrou + p14(jthk)*rsdg
      enddo
c
      phi = phisave
      return
      end
*
************************************************************************
*
