      subroutine frtsv (ncl, jx)
c  Single direct run of the model.  A. Kuusk 3.03.2025
c
      include 'par.h'
      include 'stands.h'
      include 'spectra.h'
      include 'func.h'
c     
      save sntr, tlai, tbai, uuz, nzs, rty, tlaief, efflai, 
     & ggmns, ggmnv, psgvu, bdgfu, bdgfd, btr1u, btr1d, 
     & rleff, tleff, tlty, rdsgrou, rsdgrou, rddgrou, 
     & p2bq, bdownj, bqc1, bqg1, bqm, rteff, tteff
c
      dimension dclcl3(nclmax), aspcl3(nclmax)
      dimension bdgfu(nclmax), bdgfd(nclmax)
      dimension btr1u(nclmax), btr1d(nclmax)
      dimension uuz(nzmax)
c
      ijob    = i_job
      nzs     = n_zs
      if (ijob .eq. 0) then
        jbnd  = 1
        jview = 1
      endif
      if (ijob .eq. 1 .or. ijob .gt. 2) then
        if (lopt) then
          jview = 1
          jbnd  = jx
        else
          jbnd = 1
          jview = jx
        endif
      endif
      if (ijob .eq. 2) then
        jbnd  = 1
      endif
      rlambda = wlarr(jbnd)
      jwl     = nint((rlambda - (400.d0 - wlstep))/wlstep)
c
      if (jpass .eq. 0) then
        do j = 1, 19
          x_m(j) = -99.d0
        enddo
      endif
c
      if (lstruc) then
        call strmean
     & (ncl, ths, thv, sntr, hmtree, vhekm, vhcilm, rmcrown, 
     & dbhmean, rmassm, slwm, thmm, shlm, cshm, ggmns, ggmnv, 
     & vliit, cano, efflai, tlty, tlaief, tlai, tbai, uuz)
        if (jpass .eq. 0) then
          x_m(1)  = sntr
          x_m(2)  = hmtree
          x_m(3)  = vhekm
          x_m(4)  = vhcilm
          x_m(5)  = rmcrown
          x_m(6)  = dbhmean*100.d0
          x_m(7)  = rmassm
          x_m(8)  = slwm
          x_m(10) = thmm/dr
          x_m(11) = shlm
          x_m(12) = tbai/tlaief
          x_m(13) = clmpst
	  x_m(15) = cshm
          t_lai   = tlai
          crcl    = vliit
          cacl    = cano
        endif
c                              ! calculation of probabilities
        call hetk8s
     & (ncl, jview, nzs, ths, thv, phi,  aas, aav, 
     & psgvu, bdgfu, bdgfd, btr1u, btr1d)
*       aav(jview) = aavj
        p11gr(jview) = psgvu
        sum1 = 0.d0
        sum2 = 0.d0
        sum3 = 0.d0
        sum4 = 0.d0
        do jcl = 1, ncl
          sum1 = sum1 + bdgfu(jcl)*uuu(jcl)*stdns(jcl)
*         sum2 = sum2 + bdgfd(jcl)*uuu(jcl)*stdns(jcl)
          sum3 = sum3 + btr1u(jcl)
*         sum4 = sum4 + btr1d(jcl)
        enddo
        p11lvs(jview) = sum1
        p11tr(jview)  = sum3
c
        do j = 1, ncl
          u_uu(j) = uuu(j)
        enddo
c              if ijob=0 provide the vertical profile of foliage
        if (ijob .eq. 0) then
          do j = 1, 400
             u_uz(j) = uuz(j)
          enddo
        endif
      endif
c
      if (lopt) then
        rind = refr(jwl)
c                                 ! Leaf reflectance and transmittance
        do jcl = 1, ncl
          dkl = 0.d0
          do jc = 1, ncomp3(jcl)
            dkl = dkl + ccomp3(jcl, jc)*acoef3(jcl, jwl, jc)
          enddo
          slw = slwcl(jcl)
          vai = vaicl(jcl)
          if (lmod3(jcl) .eq. 'prospect') then
            dkl = dkl/vai*slw*1.d-6
            call prospect(rind, dkl, vai, refl, tran)
          else if (lmod3(jcl) .eq. 'liberty') then
            coeff = dkl*dclcl3(jcl)/dcell0*slw*1.d-6/vai
            call liberty
     &           (thknot, p14, rind, coeff, vai, 
     &           aspcl3(jcl), rinf, refl, tran)
            if (rinf .lt. 0d0) then
              write (0, '(/a/a, f6.1/)') 'LIBERTY:', 
     &        'Cannot calculate leaf reflectance, lambda = ', rlambda
              goto 40
            endif
          endif
c
          rnlfi      = rind*rnlfc(jcl)
          if (rnlfi .lt. 1.d0) rnlfi = 1.d0
          rnlf(jcl)  = rnlfi
          rlfcl(jcl) = refl - ((1.d0 - rnlfi)/(1.d0 + rnlfi))**2
          tlfcl(jcl) = tran
          rbrnc(jcl) = brrarr(jcl, jwl)
          rtrnk(jcl) = trrarr(jcl, jwl)
        enddo
c                               ! Mean optical parameters
        call optmean
     &  (ncl, jwl, tlty, tbai, tlaief, rleff, tleff, rty, rteff, tteff)
c
        r_leff  = rleff
        t_leff  = tleff
      endif
c
c            ! Albedo of ground vegetation is calculated 
c            ! integrating ACRM in perpendicular plane, phi = pi/2
c
      phisave = phi
      phi     = pi/2.d0
      thvsave = thv
c
      call aground
     & (rsogrou, rdsgrou, rsdgrou, rddgrou)
c                             ! rddgrou = albedo of ground vegetation
      phi = phisave
      thv = thvsave
c
      call het48o
     & (ncl, stdns, uuu, eln3, thm3, rnlf, efflai, ggmns, ggmnv, ghg, 
     & psgvu, bdgfu, bdgfd, btr1u, btr1d, tlty, rteff, tteff, rtrnk, 
     & rdsgrou, rsdgrou, rddgrou, p2bq, sbgr, bdownj, bqc1, bqg1, bqm)
c
      bqq = bqc1 + bqg1 + bqm
c
      if (ijob .lt. 2 .and. jview .eq. 1) then
c                            Output results ijob=0
*       b_qc1(jview) = bqc1
*       b_qg1(jview) = bqg1
*       b_qm(jview)  = bqm
*       aavth(jview) = aav(jview)
        jx = jbnd
      else
        jx = jview
      endif
        rth(jx)   = bqq
        rsth(jx)  = sbgr
        rcr1(jx)  = bqc1
        rgr1(jx)  = bqg1
        rdif(jx)  = bqm
        bdown(jx) = bdownj
40    continue
      return
      end
*
************************************************************************
*
