      subroutine ggg
     & (th2, th1, thm, ee, szz, 
     & ellmy, ellsig, gg1, gg2)
c  G-function for a Markov chain structure
c  J. Ross,  The Radiation Regime and Architecture of Plant Stands
c  Junk,  The Hague,  1981.
c  Kuusk, A. A Markov chain model of canopy reflectance,
c  Agricult. Forest Meteorol., 1995, 76(3-4): 221-236.
c  A. Kuusk    22.03.1988 & 16.06.1992 & 20.01.2000
c  0 <= t11 < t22 <= pi/2
c
c
*     implicit double precision (a-h, o-z)
      include 'par.h'
c
*     data eps/.1d-5/
c
c
      pi4   = pi*2.d0
      pi21  = pi/2.d0
      pi12  = 1.d0/pi4
      pi14  = pi12*4.d0
      sth1  = sin(th1)
      sth2  = sin(th2)
      cth1  = cos(th1)
      cth2  = cos(th2)
c
      if (ee .lt. .4d0) then
         gg2  = .5d0
         gg1  = .5d0
         goto 99
      endif
c
      cthm  = cos(thm)
      sthm  = sin(thm)
      ct1m  = cth1*cthm
      ct2m  = cth2*cthm
      if ((th1+thm-pi21) .le. 0.d0) then
         sg1 = ct1m
      else
         sthx = ct1m/(sth1*sthm)
         sg1 = pi14*(ct1m*atan2(sthx,sqrt(1.d0 - sthx*sthx)) +
     &         sqrt((sth1*sthm)**2 - ct1m*ct1m))
      endif
      if ((th2+thm-pi21) .le. 0.d0) then
         sg2 = ct2m
      else
         sg2 = pi14*(ct2m*atan2(sthx,sqrt(1.d0 - sthx*sthx)) +
     &         sqrt((sth2*sthm)**2 - ct2m*ct2m))
      endif
c
      gg2 = 
     & max((2.653d0*ellmy+1.432d0*ellsig)*(sg2-.5d0)+.50072d0, 0.d0)
      gg1 = 
     & max((2.653d0*ellmy+1.432d0*ellsig)*(sg1-.5d0)+.50072d0, 0.d0)
c
99    continue
c
c                                  ! Regularity parameter 
c                                  ! as a function of zenith angle
c                                  ! 1 <= szz <= 2
      szs = (szz - 1.d0)*(1.d0 - cth1) + 1.d0
      szv = (szz - 1.d0)*(1.d0 - cth2) + 1.d0
c
c                         The effective G-function
      gg1  = gg1*szs
      gg2  = gg2*szv
c
      return
      end
*
******************************************************************
*
