      subroutine het48o
     & (ncl, stdns, uuu, eln3, thm3, rnlf, efflai, ggmns, ggmnv, ghg, 
     & psgvu, bdgfu, bdgfd, btr1u, btr1d, tlty, rteff, tteff, rtrnk, 
     & rdsgrou, rsdgrou, rddgrou, p2bq, sbgr, bdownj, bqc1, bqg1, bqm)
c
c   optical parameters: subroutine het48o(..)  A. Kuusk 26.09.1995
c   subroutine het48(..)  A. Kuusk  7.12.1994,
c   function het48(..),  Anne Jõeveer
c
c  Input:
c     & ncl, nsangl, thknot, phi, stdns, sqarr, 
c     & uuu, eln3, thm3, ghg, efflai, rteff, tteff, tlty, rtrnk,
c     &  aas, aav, psgvu, bdgfu, bdgfd, btr1uk, btr1dk,
c     & rlambda, bang, pkhair, 
c     & ncomp2, ul2, sl2, szz, eln2, thm2,
c     & slw2, rnc2, vai2, asp2, ccomp2,
c     & ncomp1, ul1, sl1, eln1, thm1,
c     & slw1, rnc1, vai1, asp1, ccomp1,
c     & thss, rsl1, rsl2, rsl3, rsl4, rnlf,
c     & rrs, ttt, rdsgrou, rsdgrou, rddgrou
c  Output:
c    p2bq, bdown, bqc1, bqg1, bqm
c
      include 'par.h'
      include 'spectra.h'
      include 'func.h'
c
      dimension stdns(nclmax), uuu(nclmax) 
      dimension rnlf(nclmax), rtrnk(nclmax) 
      dimension eln3(nclmax), thm3(nclmax), ghg(nclmax)
      dimension bdgfu(nclmax), bdgfd(nclmax)
      dimension btr1u(nclmax), btr1d(nclmax)
c
*     data dr/1.745329251994330d-2/
c
      jwl  = nint((rlambda - (400.d0 - wlstep))/wlstep)
c
c   single scattering
c
       call hetk8o
     & (ncl, jwl, ths, thv, phi, stdns, uuu, eln3, thm3, 
     & ghg, bdgfu, bdgfd, btr1u, btr1d, 
     & pkhair, rnlf, rtrnk, bi0u, bi0d)
c
c                                ***  S'/Q from the array sqarr,
c                                     S'/Q - direct to diffuse ratio
         sql   = sqa(jwl)
         skyl  = 1.d0 - sql
c
c   diffuse fluxes of tree crowns
c
         call diffor
     & (ths, thv, skyl, efflai, tlty, ggmns, ggmnv,
     & rteff, tteff, rdsgrou, rsdgrou, rddgrou, budif, bddif)
c
c               ! reflectance of ground vegetation r??grou was calculated
c               ! with 2-layer model ACRMf
c
         skylg = bddif/( aas*cos(ths)*pi + bddif)
c  bddif is diffuse downward flux under tree layer
c
         thets = ths
         thetv = thv
         call smcrm
     &  (thets, thetv, ggv, penalty, bc1, bs1, bdplants, bdsoil)
         sbgr = (1.d0 - skylg)*(bc1 + bs1) + bdplants + bdsoil
c
         br1gr    = sbgr*psgvu
c
*            write (0, '(a,3x,6f10.6)')
*    &       "PSGVU: ", thv/dr, ths/dr, psgvu(iths)
c
         b0       = bi0u + br1gr
         bq       = sql*b0 + budif
*            write (0, *) thv/dr, budif
         p2bq = bq
c                                          reflectance components
         bqc1 = sql*bi0u
         bqg1 = sql*br1gr
         bqm  = budif
c                                                  radiance down
         bsngld = bi0d
         bdownj = (bsngld + bddif) + aav(jview)/pi*skyl
*        print *, thv/dr, 
*    & bsngld, bddif, aav/pi*skyl, bdown(jths)
c
*     print *, thknot(1)/dr, p2bq(jths), totrans(jths), diftrans(jths)
*     enddo
c
      return
      end
*
************************************************************************
*
