      subroutine pi22u
     & (tgthx, zz12, htrj, hc1j, hc2j, rcrj, szux, vzui)
c                                       A. Kuusk   14.11.2000
c   The projection szux and volume vzui of the upper part 
c   of tree crown at the level zz12 in direction thx, cylinder+cone
c  Input:
c    tgthx, zz12, htrj, hc1j, hc2j, rcrj
c  Output:
c    szux, vzui
c   tgthx = tan(thx), htrj - tree height,
c   hc1j, hc2j - the lengths of cone and cylinder, rcrj - crown radius
c
      include 'par.h'
c      
*     data pi/3.14159265358979d0/
c
*     if (zz12 .lt. 0.d0) then
*        print *, 'Error: z = ', zz12
*        stop
*     endif
c                                                   z > htrj
      if (zz12 .ge. htrj) then
         szux = 0.d0
         vzui = 0.d0
         return
      endif
c
      vcrown = rcrj**2*pi*(hc1j/3.d0 + hc2j)
      call scone(hc1j, hc1j, rcrj, tgthx, scon)
c                                                   stem
      if (zz12 .lt. (htrj - (hc1j + hc2j))) then
         vzui = vcrown
         szux = 2.d0*hc2j*rcrj*tgthx + scon
         return
      endif
c                                                   cylinder
      hcbase = htrj - hc1j
      if (zz12 .lt. hcbase) then
         vzui  = rcrj**2*pi*(hc1j/3.d0 + hcbase - zz12)
         scylu = 2.d0*rcrj*tgthx*(hcbase - zz12)
         szux  = scylu + scon
         return
      endif
c                                                   cone
      hcz  = htrj - zz12
      rcz  = hcz*rcrj/hc1j
      vzui = rcz**2*pi*hcz/3.d0
      call scone(hcz, hcz, rcz, tgthx, szux)
c
      return
      end
*
************************************************************************
*
