      subroutine scone(hcone, hcz, rcone, tgthx, scz)
c
c  Projection of a (frustum of a) cone,  A. Kuusk   14.11.2000
c
c  Input:
c    hcone, hcz, rcone, tgthx
c  Output:
c    scz
c  hcone - the heigth of cone, 
c  hcz - the heigth of the frustum of the cone
c  rcone - base radius
c  tgthx = tg(thx), thx - the view angle
c
      include 'par.h'
      data eps/.1d-4/
c
      rhc   = rcone/hcone/max(eps, tgthx)
c                                              thx > thc
      if (rhc .lt. 1.d0) then
         hc4  = abs(hcone - hcz)
         beta = acos(rcone/(hcone*tgthx))
c                                        frustum of a cone
         if (hc4 .gt. eps) then
            rcz = rcone*hc4/hcone
            sc3 = rcz**2*beta
            sc4 = sqrt((hc4*tgthx)**2 - rcz**2)*rcz
         else
            sc3 = 0.d0
            sc4 = 0.d0
         endif
c
         sc1 = sqrt((hcone*tgthx)**2 - rcone**2)*rcone
         sc2 = rcone**2*(pi - beta)
         scz = sc2 + sc1 - sc4 + sc3
      else
         scz  = pi*rcone**2 
      endif
c
      return
      end
*
************************************************************************
*
