      subroutine strmean
     & (ncl, ths, thv, sntr, hmtree, vhekm, vhcilm, rmcrown, 
     & dbhmean, rmassm, slwm, thmm, shlm, cshm, ggmns, ggmnv, 
     & vliit, cano, efflai, tlty, tlaief, tlai, tbai, uuz)
c
c  the vertical profile of leaf area   12.2012
c  the mean G-function   12.2012
c  the mean values of structure parameters   A. Kuusk  23.09.1995
c
c  Input:
c     & (lelli, ncl, stdns, htr, hc1, hc2, rcr, dbh,
c     & rmass, slwcl, rlaicl, rbai, clmpst, clmpsh, uuu, glmp
c  Output:
c     & efflai, sntr, hmtree, vhekm, vhcilm, rmcrown, dbhmean, 
c     & rmassm, slwm, vliit, cano, tlty, tlaief, tlai, tbai
c
      include 'par.h'
      include 'stands.h'
c      
      dimension clai(nclmax), uuz(400)
c
      data gsf/.5d0/, thseff/.698d0/
c                                    gsf - G_spherical = 0.5
*     data pi/3.14159265358979d0/
c
      sntr    = 0.d0
      hmtree  = 0.d0
      vhekm   = 0.d0
      vhcilm  = 0.d0
      rmcrown = 0.d0
      dbhmean = 0.d0
      rmassm  = 0.d0
      slwm    = 0.d0
      thmm    = 0.d0
      shlm    = 0.d0
      tlaief  = 0.d0
      tlai    = 0.d0
      tbai    = 0.d0
      tlty    = 0.d0
      tclai   = 0.d0
      cshm    = 0.d0
      vliit   = 0.d0
      cano    = 0.d0
      ggmns   = 0.d0
      ggmnv   = 0.d0
      hcrmax  = 0.d0
      hcrmin  = 40.d0
      do jz = 1, 400
         uuz(jz) = 0.d0
      enddo
c                                     ! total values, mean values
      do jcl = 1, ncl
        stdj    = stdns(jcl)
        sntr    = sntr + stdj
        ri2     = rcr(jcl)**2
        vhj     = hc1(jcl) + hc2(jcl)
        htrj    = htr(jcl)
        hmtree  = hmtree + stdj*htrj
        if (htrj .gt. hcrmax) hcrmax = htrj
        if ((htrj - vhj) .lt. hcrmin) hcrmin = htrj - vhj
        vhekm   = vhekm + stdj*hc1(jcl)
        vhcilm  = vhcilm + stdj*hc2(jcl)
        rmcrown   = rmcrown + stdj*rcr(jcl)
        dbhmean   = dbhmean + stdj*dbh(jcl)
        rmassm    = rmassm  + stdj*rmass(jcl)
        slwm      = slwm    + stdj*slwcl(jcl)
        r2stdj    = stdj*ri2
        vliitcl   = r2stdj*pi
        vliit     = vliit + r2stdj
        xxy = clmpst*r2stdj
        canocl = 1.d0 - exp(-pi*xxy)
        if (canocl .gt. vliitcl) then
          wvliit = vliitcl
          wcano = canocl
          jwcl = jcl
*         print *, 'jcl,vliitcl,canocl:', jcl, vliitcl, canocl
        endif
        cano      = cano + clmpst*r2stdj
        tlty      = tlty + stdj*dbh(jcl)*.5d0*(htr(jcl) - vhj)
        rlaief    = rlaicl(jcl)*clmpsh(jcl)
        claief    = rlaief + baicl(jcl)
        clai(jcl) = claief
        tclai     = tclai + claief
        tlaief    = tlaief + rlaief
        tlai      = tlai + rlaicl(jcl)
        tbai      = tbai + baicl(jcl)
c
        rltreej = rmass(jcl)*1.d3/slwcl(jcl)
        rlaicl(jcl) = stdns(jcl)*rltreej
        tclaij = rltreej*clmpsh(jcl) + baicl(jcl)
        ri2     = rcr(jcl)**2
        if (lelli(jcl)) then
           voi = 2.d0*pi/3.d0*ri2*hc1(jcl)
        else 
           voi = pi/3.d0*ri2*(hc1(jcl) + 3.d0*hc2(jcl))
        endif
        uuu(jcl) = tclaij/voi
c   uuu(jcl) is the foliage area density in the crown of tree(jcl)
c                                     ! G-function in tree crowns
        thmx  = thm3(jcl)
        thmm  = thmm + rlaief*thmx
        eex  = 1.d0 - exp(-eln3(jcl))
        ellmyx = abs(.059d0*eln3(jcl) *(thmx - 1.02d0) + .02d0)
        ellsix = abs(.0107d0 - .0216d0*eln3(jcl)*(thmx - .265d0))
        thx = ths
        call ggg1
     & (thx, thmx, eex, ellmyx, ellsix, ggx)
        gg3s(jcl) = ggx
        ggmns = ggmns + rlaief*ggx
c
        thx = thv
        call ggg1
     & (thx, thmx, eex, ellmyx, ellsix, ggx)
        gg3v(jcl) = ggx
        ggmnv = ggmnv + rlaief*ggx
        shlm  = shlm + rlaief*shl(jcl)
        cshm  = cshm + rlaief*clmpsh(jcl)
      enddo
c
      hmtree  = hmtree/sntr
      vhekm   = vhekm/sntr
      vhcilm  = vhcilm/sntr
      rmcrown = rmcrown/sntr
      dbhmean = dbhmean/sntr
      rmassm  = rmassm/sntr
      slwm    = slwm/sntr
      thmm    = thmm/tlaief
      shlm    = shlm/tlaief
      cshm    = cshm/tlaief
      ggmns   = ggmns/tlaief
      ggmnv   = ggmnv/tlaief
      vliit   = pi*vliit
      cano    = 1.d0 - exp(-pi*cano)
      tlty    = pi*tlty
c
********************  LAI_eff for diffuse fluxes (09.2002) *****************
c                     thseff = 40° = .698 rad
      thets   = thseff
      cthets  = cos(thets)
      tgths   = sin(thets)/cthets
      alsc    = 0.d0
      zz12    = 0.d0
c 
      vaheg  = 1.d0 - glmp
      do jcl = 1, ncl
        rcrj   = rcr(jcl)
        htrj   = htr(jcl)
        hc1j   = hc1(jcl)
        cellj  = hc1j/2.d0
        hc2j   = hc2(jcl)
        if (lelli(jcl)) then
          call pi11u
     &    (tgths, zz12, htrj, cellj, rcrj, szu1, vzui)
        else
          call pi22u
     & (tgths, zz12, htrj, hc1j, hc2j, rcrj, szu1, vzui)
        endif
        if (szu1 .gt. 0.d0) then
           a1gr = exp(-gsf*clai(jcl)/(stdns(jcl)*szu1*cthets))
        else
           a1gr = 1.d0
        endif
        if (abs(vaheg) .gt. 0.1d-3) then
           b10i  = -log(1.d0 - (1.d0 - a1gr)*vaheg)/vaheg
        else
           b10i  = 1.d0 - a1gr
        endif
        alsc  = alsc + stdns(jcl)*szu1*b10i
      enddo
c
         efflai = cthets*alsc
c
************** Vertical profile of leaf area (18.12.2012) ****************
c              step = 0.1 m
      jzmax = int(hcrmax*10.d0) + 1
      jzmin = max(int(hcrmin*10.d0)-1, 1)
      do jz = jzmin, jzmax
        zj = jz*0.1d0
        do jcl = 1, ncl
          rcrj   = rcr(jcl)
          htrj  = htr(jcl)
          hc1j   = hc1(jcl)
          hc2j   = hc2(jcl)
          zmin   = htrj - hc1j - hc2j
          if (zj .gt. zmin .and. zj .lt. htrj) then
            if (lelli(jcl)) then
              cellj  = hc1j/2.d0
              z2 = zj - (zmin + htrj)/2.d0
              rz = rcrj*sqrt(cellj*cellj - z2*z2)/cellj
            else
              if (zj .lt. htrj-hc1j) then
                 rz = rcrj
              else
                 rz = rcrj*(htrj - zj)/hc1j
              endif
            endif
            uuz(jz) = uuz(jz) + pi*rz*rz*uuu(jcl)*stdns(jcl)
          endif
        enddo
      enddo
c
      return
      end
*
************************************************************************
*
